<?php // Include only
/*
OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wacintaki Poteto modifications Copyright 2004-2005 Marc "Waccoon" Leveille, http://www.NineChime.com/Wacintosh.htm
Version 1.1.5 - Last modified 3/13/2005
*/


// Auto-slashes test
if (!get_magic_quotes_gpc()) {
	function slashit($in) {
		return addslashes($in);
	}
} else {
	set_magic_quotes_runtime(0);

	function slashit($in) {
		return $in;
	}
}


// Microtime
function get_microtime() {
	$mtime = microtime();
	$mtime = explode(' ', $mtime);
	return doubleval($mtime[1]) + doubleval($mtime[0]);
}


// Flag check function
// Code contributed by Marcello (http://www.cellosoft.com)
function check_flag($c) {
	global $usrflags;
	return is_integer (strpos($usrflags, $c));
}
// <RanmaGuy> ill give you credit too :P in the file
// <marcello> hehe "thanks to marcello, I might actually have some miniscule speck of a clue on what I'm doing"


// Check for chars that break database
function badChars($text) {
	// Code from PHP.net

	$illegal = array('\'', '"', '$', '#', '&', '+', '=', '*', '/', '\\', ':', ';');
	$garb = array();

	foreach ($illegal as $k) {
		while (($j = strpos ($text, $k)) !== FALSE) {
			$garb[] = $text{$j};
			$text = substr ($text, 0, $j).substr ($text, $j + 1);
		}
	}
	$garb = array_unique ($garb);

	return $garb;
}


// Prepare path input (UNIX/URI only)
function strip_path($in) {
	// Strip trailing slash(es)
	$in = preg_replace ('/\/+$/', '', $in);

	// Strip root, but not backtick
	$in = preg_replace ('/^(\.\/)+/', '', $in);

	return $in;
}


// Checks for empty file
function check_file($in) {
	if (file_exists ($in) && filesize ($in) > 0) {
		return 1;
	} else {
		return 0;
	}
}


function get_filetype(&$data) {
	// Get types in approx. order of popularity

	$type = '';
	if (substr ($data, 0, 8) == "\x89PNG\x0D\x0A\x1A\x0A") {
		$type = 'png';
	} elseif (substr ($data, 0, 2) == "\xFF\xD8") {
		// JFIF only.  EXIF is not allowed.
		$type = 'jpg';
	} elseif (substr ($data, 0, 3) == 'GIF') {
		$type = 'gif';
	} elseif (substr ($buffer, 0, 2) == 'BM') {
		$type = 'bmp';
	} elseif (substr ($data, 0, 23) == "\x00\x00\x00\x0CjP\x20\x20\x0D\x0A\x87\x0A\x00\x00\x00\x14ftypjp2") {
		$type = 'jp2';
	} elseif (substr ($buffer, 0, 4) == '8BPS') {
		// Note: 8-bit, 16-bit, and HDR images have same header
		$type = 'psd';
	} elseif (substr ($data, 0, 2) == 'PK') {
		$type = 'zip';
	}

	return $type;
}


function get_age($in) {
	// Check if an age already.
	// Age has no dashes.
	if (empty ($in)) {
		return '';
	}
	if (strpos ($in, '-') === FALSE) {
		return intval ($in);
	}

	// Age from birthday
	// Thanks to Jean-Marc on the LiquidPulse.net forum
	list ($year, $month, $day) = explode ('-', $in);
	$z = -5; // Timezone

	$yeardiff =  gmdate ('Y', time() + $z * 3600) - intval($year);
	$monthdiff = gmdate ('m', time() + $z * 3600) - intval($month);
	$daydiff =   gmdate ('j', time() + $z * 3600) - intval($day);

	if (($monthdiff < 0) || (($monthdiff == 0) && ($daydiff <= 0) )) {
		$age = $yeardiff - 1;
	} else {
		$age = $yeardiff;
	}

	return $age;
}


function decode_birthday($year, $month, $day) {
	$year  = (int) $year;
	$month = (int) $month;
	$day   = (int) $day;

	if ($year < 1900) {
		return '';
	}

	if ($month < 1 || $month > 12) {
		$month = '??';
	} else {
		$month = sprintf ('%02d', $month);
	}
	if ($day < 1 || $day > 31) {
		$day = '??';
	} else {
		$day = sprintf ('%02d', $day);
	}

	return $year.'-'.$month.'-'.$day;
}


// Web printing functions
function sql_check($result, $extra = '') {
	if (!$result) {
		echo mysql_error();
		if (!empty ($extra)) {
			echo ' ['.$extra.']';
		}
		echo "<br />\n";
		return 0;
	}
	return 1;
}
function web_line($line) {
	echo $line."<br />\n";
}


// Version number processing
// Returns keyed array of "usable" numbers
// INPUT: 'modname-x.y.z', 'x.y.z', 'modname-x.y', 'x.y' patterns
/* OUTPUT:
	'mod'=>'modname'
	'ver'=>"%03d%03d%03d" (5.12.14 = 005012014),
	'major'=>major num
	'minor'=>minor num
	'rev'=>revision num (build)
*/
function version_split($input) {
	if ($input == 'Wac1.0') {
		// 'Wac1.0' fix
		return array ('mod'=>'wac', 'ver'=>1000000, 'major'=>1, 'minor'=>0, 'rev'=>0 );
	}

	// Note reverse search, so dashes can be in mod name
	$split = strrpos ($input, '-');

	if ($split) {
		// If there's a dash, get the mod name
		$ver_name = substr ($input, 0, $split);
		$ver_num  = substr ($input, $split + 1);
		$small = explode ('.', $ver_num);
	} else {
		$small = explode ('.', $input);
	}

	if (count($small) > 1) {
		// Major & minor required, revision optional
		if (!defined($small[2])) {
			$small[2] = 0;
		}
		$ver_num = ($small[0] * 1000000) + ($small[1] * 1000) + intval ($small[2]);

		return array ('mod'=>$ver_name, 'ver'=>$ver_num, 'major'=>$small[0], 'minor'=>$small[1], 'rev'=>$small[2] );
	} else {
		// Not a valid number!
		return 0;
	}
}


// Returns a string from an array, with seperators and delimiters.
function make_list(&$array, $sep, $delimiter = '') {
	$list = '';
	$items = count ($array);

	if ($items == 1) {
		return $delimiter.$array[0].$delimiter;
	} elseif ($items > 0) {
		for ($i = 0; $i < ($items - 1); $i++) {
			$list .= $delimiter.$array[$i].$delimiter.$sep;
		}
		$list .= $delimiter.$array[$i].$delimiter;

		return $list;
	}
}


// "Not Empty" Echo.  Prints nothing, or alternate $if_empty, if $string is empty.
// Whether multiple strings can be supported (with an array) is a design issue.  Should all or only some strings be populated for $format to print?
function ne_echo($string, $if_empty, $format = '') {
	$string = trim ($string);
	if (!empty ($string)) {
		if (!empty ($format)) {
			echo (str_replace ('{s}', $string, $format));
		} else {
			echo $string;
		}
	} else {
		echo $if_empty;
	}
	return;
}


// Deluxe page numbers
// Takes a keyed array of paramaters ($in) and returns an HTML-formatted block of page numbers
function full_page_numbers($first, $current, $total, $display, $link, $in) {
	/*
	$first = First page number.  Some BBSes use 0 as the first page, others 1.
	$display = Number of pages to show per side of the current page.  0 = use default.

	$in = array:
	prev_enabled  => Linked "Prev", parsed for '{page}'
	prev_disabled => Unlinked "Prev"
	next_enabled  => Linked "Next", parsed for '{page}'
	next_disabled => Unlinked "Next"
	button_sep    => Seperates Prev/Next from numbers
	link_format   => Link format (for classes, etc), parsed for '{page}'
	active_format => Span for current [active] number, parsed for '{page}'
	elipses       => Seperator for first/last numbers and all others
	page_sep      => Seperator between numbers
	*/

	// Fixes offset issue with some BBSes
	function offset_replace($offset, $number, $string) {
		$old = array ('{page_link}', '{page}');
		$new = array ($number + $offset, $number);
		return str_replace ($old, $new, $string);
	}

	// Set up
	$output = '';
	if ($display < 1) {
		$display = 4;
	}
	if ($first == 0) {
		$offset = -1;
		$first += 1;
		$current += 1;
	} else {
		$offset = 0;
	}
	$page_link = str_replace ('{link}', $link, $in['link_format']);
	$in['prev_enabled'] = str_replace ('{link}', $link, $in['prev_enabled']);
	$in['next_enabled'] = str_replace ('{link}', $link, $in['next_enabled']);

	// Get our extremes
	$list_start = 1;
	$list_end   = $total;
	if ($current > $display + 1) {
		$list_start = $current - $display;
	}
	if ($total - $current > $display) {
		$list_end = $current + $display;
	}

	// Print start block
	if ($current > 1) {
		$output .= offset_replace($offset, $current - 1, $in['prev_enabled']);
	} else {
		$output .= $in['prev_disabled'];
	}
	$output .= $in['button_sep'];

	// Print start number?
	if ($list_start > 1) {
		$output .= offset_replace($offset, 1, $page_link);
		$output .= $in['elipses'];
	}

	// Print all numbers
	for ($i = $list_start; $i <= $list_end; $i++) {
		if ($i == $current) {
			$output .= offset_replace($offset, $i, $in['active_format']);
		} else {
			$output .= offset_replace($offset, $i, $page_link);
		}
		if ($i != $list_end) $output .= $in['page_sep'];
	}

	// Print end number?
	if ($list_end < $total) {
		$output .= $in['elipses'];
		$output .= offset_replace($offset, $total, $page_link);
	}

	// Print end block
	$output .= $in['button_sep'];
	if ($current < $total) {
		$output .= offset_replace($offset, $current + 1, $in['next_enabled']);
	} else {
		$output .= $in['next_disabled'];
	}

	return $output;
}


// Simple page numbers (no images)
// Easy, format-free wrapper for full_page_numbers()
function quick_page_numbers($first, $current, $total, $display, $link) {
	$page_settings = array (
		'prev_enabled'  => '<a href="{link}">&lt;&lt;PREV</a>',
		'prev_disabled' => '&lt;&lt;PREV',
		'next_enabled'  => '<a href="{link}">NEXT&gt;&gt;</a>',
		'next_disabled' => 'NEXT&gt;&gt;',
		'button_sep'    => ' &middot; ',
		'link_format'   => '<a href="{link}">[{page}]</a>',
		'active_format' => '<b>[{page}]</b>',
		'elipses'       => ' ... ',
		'page_sep'      => ' '
	);

	return full_page_numbers($first, $current, $total, $display, $link, $page_settings);
}
?>